#############################################################
#
# kudzu
#
#############################################################
KUDZU_VERSION=1.2.36
KUDZU_SOURCE:=kudzu-$(KUDZU_VERSION).tar.gz
KUDZU_SITE:=http://download.fedora.redhat.com/pub/fedora/linux/core/development/SRPMS/
KUDZU_DIR:=$(BUILD_DIR)/kudzu-$(KUDZU_VERSION)
KUDZU_CAT:=zcat
KUDZU_CFLAGS:=-D_GNU_SOURCE -D__LOADER__ -Os -Wall

KUDZU_BINARY:=kudzu
KUDZU_TARGET_BINARY:=usr/bin/kudzu

$(DL_DIR)/kudzu-$(KUDZU_VERSION)-1.src.rpm:
	$(WGET) -P $(DL_DIR) $(KUDZU_SITE)/kudzu-$(KUDZU_VERSION)-1.src.rpm

$(DL_DIR)/$(KUDZU_SOURCE):
	rpm2cpio $(DL_DIR)/kudzu-$(KUDZU_VERSION)-1.src.rpm | (cd $(DL_DIR); cpio -i --make-directories)

kudzu-source: $(DL_DIR)/kudzu-$(KUDZU_VERSION)-1.src.rpm $(DL_DIR)/$(KUDZU_SOURCE)

$(KUDZU_DIR)/.unpacked: $(DL_DIR)/$(KUDZU_SOURCE)
	$(KUDZU_CAT) $(DL_DIR)/$(KUDZU_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $(KUDZU_DIR)/.unpacked

$(KUDZU_DIR)/.patched: $(KUDZU_DIR)/.unpacked
	toolchain/patch-kernel.sh $(KUDZU_DIR) package/kudzu/ kudzu\*.patch
	touch $(KUDZU_DIR)/.patched

$(KUDZU_DIR)/.configured: $(KUDZU_DIR)/.patched
	touch $(KUDZU_DIR)/.configured

$(KUDZU_DIR)/libkudzu.a: $(KUDZU_DIR)/.configured
	make -C $(KUDZU_DIR) $(TARGET_CONFIGURE_OPTS) CFLAGS="$(KUDZU_CFLAGS)" libkudzu.a
	touch -c $(KUDZU_DIR)/libkudzu.a

$(STAGING_DIR)/lib/libkudzu.a: $(KUDZU_DIR)/libkudzu.a
	install -m 644 $(KUDZU_DIR)/libkudzu.a $(STAGING_DIR)/lib;
	install -m 755 -d $(STAGING_DIR)/include/kudzu
	for header in $(KUDZU_DIR)/*.h ; do \
		install -m 644 $$header $(STAGING_DIR)/include/kudzu ; \
	done
	touch -c $(STAGING_DIR)/lib/libkudzu.a

kudzu: uclibc pciutils $(STAGING_DIR)/lib/libkudzu.a

kudzu-clean:
	-$(MAKE) -C $(KUDZU_DIR) clean
	rm -f $(KUDZU_DIR)/.configured

kudzu-dirclean:
	rm -rf $(KUDZU_DIR)
#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_KUDZU)),y)
TARGETS+=kudzu
endif
