#############################################################
#
# parted
#
#############################################################
PARTED_VERSION:=1.7.1
PARTED_SOURCE:=parted-$(PARTED_VERSION).tar.gz
PARTED_SITE:=http://ftp.gnu.org/gnu/parted
PARTED_CAT:=zcat
PARTED_DIR:=$(BUILD_DIR)/parted-$(PARTED_VERSION)
PARTED_BINPACKAGE:=parted-$(PARTED_VERSION)-inst.tar.gz

$(DL_DIR)/$(PARTED_SOURCE):
	 $(WGET) -P $(DL_DIR) $(PARTED_SITE)/$(PARTED_SOURCE)

parted-source: $(DL_DIR)/$(PARTED_SOURCE)

$(PARTED_DIR)/.unpacked: $(DL_DIR)/$(PARTED_SOURCE)
	$(PARTED_CAT) $(DL_DIR)/$(PARTED_SOURCE) | tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	toolchain/patch-kernel.sh $(PARTED_DIR) package/parted \*.patch
	touch $(PARTED_DIR)/.unpacked

$(PARTED_DIR)/.configured: $(PARTED_DIR)/.unpacked
	(cd $(PARTED_DIR); \
		./configure --prefix=/usr \
			--enable-shared \
			--enable-part-static \
			--enable-pc98=no \
			--disable-dynamic-loading \
			--without-readline \
			--disable-nls \
			--enable-Werror=no \
	);
	touch $(PARTED_DIR)/.configured

$(PARTED_DIR)/parted/parted: $(PARTED_DIR)/.configured
	$(MAKE) -C $(PARTED_DIR)
	touch -c $(PARTED_DIR)/parted/parted

$(BIN_DIR)/$(PARTED_BINPACKAGE): $(PARTED_DIR)/parted/parted
	-rm -rf $(PACK_DIR)/parted
	-mkdir $(PACK_DIR)/parted
	$(MAKE) -C $(PARTED_DIR) \
		DESTDIR=$(PACK_DIR)/parted \
		install
	tar -czf $(BIN_DIR)/$(PARTED_BINPACKAGE) -C $(PACK_DIR)/parted .
	touch -c $(BIN_DIR)/$(PARTED_BINPACKAGE)

parted: $(BIN_DIR)/$(PARTED_BINPACKAGE)

parted-clean:
	-$(MAKE) -C $(PARTED_DIR) clean

parted-dirclean:
	rm -rf $(PARTED_DIR)

#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_PARTED)),y)
BINDIR_TARGETS+=parted
endif
