#!/usr/bin/python
# Copyright (C) 2003, Charles Wang.
# Author:  Charles Wang <charles@linux.net.cn>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANT; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public LIcense for more
# details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA.

import os.path
import mi_core

def select(bindir, fromdir, todir):
    ver = '4.4.0-11mgc.i686'
    mi_core.rpmselect(bindir, fromdir, todir,
                      'XFree86-%s.rpm' % ver,
                      ['etc/X11',
                       'usr/X11R6/bin/X',
                       'usr/X11R6/bin/XFree86',
                       'usr/X11R6/bin/xinit',
                       'usr/X11R6/bin/xset',
                       'usr/X11R6/lib/X11/xinit',
                       'usr/X11R6/lib/modules/codeconv/libISO8859_1.a',
                       'usr/X11R6/lib/modules/codeconv/libGBK.a',
                       'usr/X11R6/lib/modules/drivers/fbdev_drv.o',
                       'usr/X11R6/lib/modules/drivers/i810_drv.o',
                       'usr/X11R6/lib/modules/drivers/vesa_drv.o',
                       'usr/X11R6/lib/modules/extensions/libextmod.a',
                       'usr/X11R6/lib/modules/fonts/libbitmap.a',
                       'usr/X11R6/lib/modules/input/kbd_drv.o',
                       'usr/X11R6/lib/modules/input/mouse_drv.o',
                       'usr/X11R6/lib/modules/libddc.a',
                       'usr/X11R6/lib/modules/libfb.a',
                       'usr/X11R6/lib/modules/libxaa.a',
                       'usr/X11R6/lib/modules/libramdac.a',
                       'usr/X11R6/lib/modules/libpcidata.a',
                       'usr/X11R6/lib/modules/libscanpci.a',
                       'usr/X11R6/lib/modules/libshadow.a',
                       'usr/X11R6/lib/modules/libvbe.a',
                       'usr/X11R6/lib/modules/libvgahw.a',
                       'usr/X11R6/lib/modules/linux/libfbdevhw.a',
                       'usr/X11R6/lib/modules/linux/libint10.a'],
                      ['etc/X11/xserver',
                       'usr/X11R6/lib/X11/xkb'])
    mi_core.rpmselect(bindir, fromdir, todir,
                      'XFree86-libs-%s.rpm' % ver,
                      ['usr/X11R6/lib/libICE.so.*',
                       'usr/X11R6/lib/libSM.so.*',
                       'usr/X11R6/lib/libX11.so.*',
                       'usr/X11R6/lib/libXcursor.so.*',
                       'usr/X11R6/lib/libXext.so.*',
                       'usr/X11R6/lib/libXfont.so.*',
                       'usr/X11R6/lib/libXft.so.*',
                       'usr/X11R6/lib/libXi.so.*',
                       'usr/X11R6/lib/libXmuu.so.*',
                       'usr/X11R6/lib/libXrandr.so.*',
                       'usr/X11R6/lib/libXrender.so.*',
                       'usr/X11R6/lib/libXt.so.*',
                       'usr/X11R6/lib/libXinerama.so.*',
                       'usr/X11R6/lib/libxkbfile.so.*'
                       ],
                      ['usr/X11R6/lib/X11/locale/lib/common'])
    mi_core.rpmselect(bindir, fromdir, todir,
                      'XFree86-libs-data-%s.rpm' % ver,
                      ['usr/X11R6/lib/X11/XErrorDB',
                       'usr/X11R6/lib/X11/XKeysymDB',
                       'usr/X11R6/lib/X11/locale/compose.dir',
                       'usr/X11R6/lib/X11/locale/locale.alias',
                       'usr/X11R6/lib/X11/locale/locale.dir',
                       'usr/X11R6/lib/X11/rgb.txt'],
                      ['usr/X11R6/lib/X11/locale/C',
                       'usr/X11R6/lib/X11/locale/en_US.UTF-8',
                       'usr/X11R6/lib/X11/locale/iso8859-1',
                       'usr/X11R6/lib/X11/locale/zh_CN.gb18030',
                       'usr/X11R6/lib/X11/locale/zh_CN'])
    # Run ldconfig if needed.
    mi_core.system(mi_core.ldconfig_cmdfmt %
                   { 'root' : todir, 'libpath' : '/usr/X11R6/lib' })

    fontfilelist = []
    x_fontlist = ['cursor.pcf.gz',
                  '6x13-ISO8859-1.pcf.gz', '6x13B-ISO8859-1.pcf.gz',
                  '7x14-ISO8859-1.pcf.gz', '7x14B-ISO8859-1.pcf.gz',
                  '8x16.pcf.gz', 'clR8x16.pcf.gz', 'clB8x16.pcf.gz' #, 'gb16fs.pcf.gz'
                  ]
    x_fontdir = 'usr/X11R6/lib/X11/fonts/misc/'
    for f in x_fontlist:
        fontfilelist.append(x_fontdir + f)

    ttf_fontlist = ['sunglobe.ttf'] #['simsun.ttf', 'tahoma.ttf']
    ttf_fontdir = 'usr/share/fonts/ttf/zh_CN/'
    for f in ttf_fontlist:
        fontfilelist.append(ttf_fontdir + f)

    mi_core.system("rm -rf %s; mkdir -p %s" % (fromdir, fromdir))
    mi_core.rpminst(bindir, fromdir, 'libgcc-3.4.3-6mgc.i686.rpm')
    mi_core.rpminst(bindir, fromdir, 'libstdc++-3.4.3-6mgc.i686.rpm')
    mi_core.rpminst(bindir, fromdir, 'XFree86-libs-%s.rpm' % ver)
    mi_core.rpminst(bindir, fromdir, 'XFree86-base-fonts-%s.rpm' % ver)
    mi_core.tgzinst(bindir, fromdir, 'ttfonts-zh_CN-2.14-10.tar.bz2') #'zhttf-fonts-1.2-1mgc.i686.rpm')
    mi_core.rpminst(bindir, fromdir, 'XFree86-font-utils-%s.rpm' % ver)
    #mi_core.rpminst(bindir, fromdir, 'fontconfig-2.2.3-7mgc.i686.rpm')
    #mi_core.rpminst(bindir, fromdir, 'ttmkfdir-3.0.9-14mgc.i686.rpm')
    mi_core.select(fromdir, todir,
                   ['lib/libgcc_s*.so.1',
                    'usr/lib/libstdc++.so.6*',
                    'usr/X11R6/bin/mkfontdir',
                    'usr/X11R6/bin/mkfontscale', # added
                    'usr/X11R6/lib/libfontenc.so.*',
                    'usr/X11R6/lib/X11/fonts/encodings/encodings.dir',
                    'usr/X11R6/lib/X11/fonts/encodings/large/encodings.dir',
                    'usr/X11R6/lib/X11/fonts/encodings/large/gbk-0.enc.gz',
                    'usr/X11R6/lib/X11/fonts/encodings/large/gb18030.2000-1.enc.gz',
                    'usr/X11R6/lib/X11/fonts/misc/fonts.alias' #, 'usr/bin/ttmkfdir'
                    ]
                   + fontfilelist,
                   [])
    # Setup for chroot.
    #mi_core.system("cp -a %s/* %s" % (todir, fromdir))
    chrootcmd = 'LD_LIBRARY_PATH=/usr/X11R6/lib /usr/sbin/chroot %s' % todir

    #mi_core.system("%s /usr/bin/ttmkfdir -d /%s -o /%sfonts.scale" % (chrootcmd, ttf_fontdir, ttf_fontdir))

    for fontdir in [x_fontdir, ttf_fontdir]:
        mi_core.system("%s /usr/X11R6/bin/mkfontdir /%s" % (chrootcmd, fontdir))
        #mi_core.system("%s /usr/bin/fc-cache /%s" % (chrootcmd, fontdir))

    #mi_core.select(fromdir, todir,
    #               ['usr/X11R6/lib/X11/fonts/misc/fonts.*'],
    #               [])
    mi_core.system("rm -f %s" % ' '.join(map(lambda f: os.path.join(todir, f),
                                    ['usr/X11R6/bin/mkfontdir',
                                     'usr/X11R6/bin/mkfontscale',
                                     'usr/X11R6/lib/libXfont.so.*',
                                     'usr/bin/fc-cache'])))

    # The font exists in /usr/X11R6/lib/X11/fonts/* do not need fonts.cache-1.
    # If any /usr/share/fonts/* is included, fc-cache can be run to generate
    # fonts.cache-1 to speed up the rendering of the fonts. Note that
    # /etc/fonts/* have to be copied into todir.
