#!/usr/bin/python
# Copyright (C) 2003, Charles Wang.
# Author:  Charles Wang <charles@linux.net.cn>
# All rights reserved.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 2, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANT; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public LIcense for more
# details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA.

import os.path
import mi_core

def select(bindir, fromdir, todir):
    mi_core.rpmselect(bindir, fromdir, todir,
                      'xorg-x11-server-Xorg-1.2.0-5mgc.i686.rpm',
                      ['usr/X11R6/bin/X',
                       'usr/X11R6/bin/Xorg',
                       'usr/X11R6/bin/gtf',
                       'usr/X11R6/lib/modules/extensions/libextmod.so',
                       #'usr/X11R6/lib/modules/fonts/libbitmap.so',
                       'usr/X11R6/lib/modules/libddc.so',
                       'usr/X11R6/lib/modules/libfb.so',
                       'usr/X11R6/lib/modules/libxaa.so',
                       'usr/X11R6/lib/modules/libramdac.so',
                       'usr/X11R6/lib/modules/libpcidata.so',
                       #'usr/X11R6/lib/modules/libscanpci.so',
                       'usr/X11R6/lib/modules/libshadow.so',
                       'usr/X11R6/lib/modules/libvbe.so',
                       'usr/X11R6/lib/modules/libvgahw.so',
                       'usr/X11R6/lib/modules/linux/libfbdevhw.so',
                       'usr/X11R6/lib/modules/libint10.so'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'xorg-x11-xinit-1.0.2-1mgc.i686.rpm',
                      ['usr/X11R6/bin/xinit'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'xorg-x11-drivers-7.1-3mgc.i686.rpm',
                      ['usr/X11R6/lib/modules/drivers/fbdev_drv.so',
                       'usr/X11R6/lib/modules/drivers/i810_drv.so',
                       'usr/X11R6/lib/modules/drivers/vesa_drv.so',
                       'usr/X11R6/lib/modules/input/kbd_drv.so',
                       'usr/X11R6/lib/modules/input/mouse_drv.so'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'libICE-1.0.3-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libICE.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libSM-1.0.2-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libSM.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXcursor-1.1.7-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libXcursor.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXext-1.0.2-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXext.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXfont-1.2.6-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXfont.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXft-2.1.12-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXft.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXi-1.0.2-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXi.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXmu-1.0.3-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXmuu.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXrandr-1.1.2-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXrandr.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXrender-0.9.2-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXrender.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXt-1.0.4-1mgc.i686.rpm',
                      ['usr/X11R6/lib/libXt.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXinerama-1.0.1-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libXinerama.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libxkbfile-1.0.3-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libxkbfile.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXfixes-4.0.1-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libXfixes.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libfontenc-1.0.3-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libfontenc.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXau-1.0.1-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libXau.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,'libXdmcp-1.0.1-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libXdmcp.so.*'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'xorg-x11-server-utils-7.1-2mgc.i686.rpm',
                      ['usr/X11R6/lib/X11/rgb.txt'],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'libX11-1.0.3-2mgc.i686.rpm',
                      ['usr/X11R6/lib/libX11.so.*',
                       'usr/X11R6/lib/X11/XErrorDB',
                       'usr/X11R6/lib/X11/XKeysymDB',
                       'usr/X11R6/lib/X11/locale/compose.dir',
                       'usr/X11R6/lib/X11/locale/locale.alias',
                       'usr/X11R6/lib/X11/locale/locale.dir',
                       ],
                      ['usr/X11R6/lib/X11/locale/C',
                       'usr/X11R6/lib/X11/locale/en_US.UTF-8',
                       'usr/X11R6/lib/X11/locale/iso8859-1',
                       'usr/X11R6/lib/X11/locale/zh_CN.gb18030',
                       'usr/X11R6/lib/X11/locale/zh_CN'])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'xorg-x11-xkbdata-1.0.1-1mgc.noarch.rpm',
                      ['usr/X11R6/lib/X11/xkb/keycodes/xfree86',
                       'usr/X11R6/lib/X11/xkb/keycodes/aliases',
                       'usr/X11R6/lib/X11/xkb/geometry/pc',
                       'usr/X11R6/lib/X11/xkb/types/complete',
                       'usr/X11R6/lib/X11/xkb/types/basic',
                       'usr/X11R6/lib/X11/xkb/types/mousekeys',
                       'usr/X11R6/lib/X11/xkb/types/pc',
                       'usr/X11R6/lib/X11/xkb/types/iso9995',
                       'usr/X11R6/lib/X11/xkb/types/level5',
                       'usr/X11R6/lib/X11/xkb/types/extra',
                       'usr/X11R6/lib/X11/xkb/compat/complete',
                       'usr/X11R6/lib/X11/xkb/compat/basic',
                       'usr/X11R6/lib/X11/xkb/compat/ledcaps',
                       'usr/X11R6/lib/X11/xkb/compat/lednum',
                       'usr/X11R6/lib/X11/xkb/compat/iso9995',
                       'usr/X11R6/lib/X11/xkb/compat/mousekeys',
                       'usr/X11R6/lib/X11/xkb/compat/accessx',
                       'usr/X11R6/lib/X11/xkb/compat/misc',
                       'usr/X11R6/lib/X11/xkb/compat/ledscroll',
                       'usr/X11R6/lib/X11/xkb/compat/xfree86',
                       'usr/X11R6/lib/X11/xkb/compat/level5',
                       'usr/X11R6/lib/X11/xkb/symbols/pc',
                       'usr/X11R6/lib/X11/xkb/symbols/us',
                       'usr/X11R6/lib/X11/xkb/rules/base',
                       'usr/X11R6/lib/X11/xkb/rules/xorg',
                       'usr/X11R6/lib/X11/xkb/rules/xfree86',
                       ],
                      [])

    mi_core.rpmselect(bindir, fromdir, todir,
                      'xorg-x11-xkb-utils-1.0.2-2mgc.i686.rpm',
                      ['usr/X11R6/bin/xkbcomp'],
                      [])
                       
    mi_core.system('ln -s /tmp/server-0.xkm %s' % \
                   os.path.join(todir, 'usr/X11R6/lib/X11/xkb/'))

    # Run ldconfig if needed.
    mi_core.system(mi_core.ldconfig_cmdfmt %
                   { 'root' : todir, 'libpath' : '/usr/X11R6/lib' })

    fontfilelist = []
    x_fontlist = ['cursor.pcf.gz',
                  '6x13-ISO8859-1.pcf.gz', '6x13B-ISO8859-1.pcf.gz',
                  '7x14-ISO8859-1.pcf.gz', '7x14B-ISO8859-1.pcf.gz',
                  '8x16.pcf.gz', 'clR8x16.pcf.gz', 'clB8x16.pcf.gz', #'gb16fs.pcf.gz'
                  'wenquanyi_9pt.pcf' # in fonts-zh_CN-1.tar.bz2
                  ]

    x_fontdir = 'usr/X11R6/lib/X11/fonts/misc/'
    for f in x_fontlist:
        fontfilelist.append(x_fontdir + f)

    mi_core.system("rm -rf %s; mkdir -p %s" % (fromdir, fromdir))
    mi_core.rpminst(bindir, fromdir, 'libgcc-3.4.4-1mgc.i686.rpm')
    mi_core.rpminst(bindir, fromdir, 'libstdc++-3.4.4-1mgc.i686.rpm')
    mi_core.rpminst(bindir, fromdir, 'xorg-x11-fonts-base-7.1-1mgc.noarch.rpm')
    mi_core.rpminst(bindir, fromdir, 'xorg-x11-fonts-misc-7.1-1mgc.noarch.rpm')
    mi_core.tgzinst(bindir, fromdir, 'fonts-zh_CN-1.tar.bz2')
    mi_core.rpminst(bindir, fromdir, 'xorg-x11-font-utils-7.1-1mgc.i686.rpm')
    #mi_core.rpminst(bindir, fromdir, 'fontconfig-2.2.3-7mgc.i686.rpm')
    #mi_core.rpminst(bindir, fromdir, 'ttmkfdir-3.0.9-15mgc.i686.rpm')
    mi_core.select(fromdir, todir,
                   ['lib/libgcc_s*.so.1',
                    'usr/lib/libstdc++.so.6*',
                    'usr/X11R6/bin/mkfontdir',
                    'usr/X11R6/bin/mkfontscale', # added
                    #'usr/X11R6/lib/X11/fonts/encodings/encodings.dir',
                    #'usr/X11R6/lib/X11/fonts/encodings/large/encodings.dir',
                    'usr/X11R6/lib/X11/fonts/encodings/large/gbk-0.enc.gz',
                    'usr/X11R6/lib/X11/fonts/encodings/large/gb18030.2000-1.enc.gz',
                    'usr/X11R6/lib/X11/fonts/misc/fonts.alias' #, 'usr/bin/ttmkfdir'
                    ]
                   + fontfilelist,
                   [])
    # Setup for chroot.
    #mi_core.system("cp -a %s/* %s" % (todir, fromdir))
    chrootcmd = 'LD_LIBRARY_PATH=/usr/X11R6/lib /usr/sbin/chroot %s' % todir

    #mi_core.system("%s /usr/bin/ttmkfdir -d /%s -o /%sfonts.scale" % (chrootcmd, ttf_fontdir, ttf_fontdir))

    for fontdir in [x_fontdir]: #, ttf_fontdir]:
        mi_core.system("%s /usr/X11R6/bin/mkfontdir /%s" % (chrootcmd, fontdir))
        #mi_core.system("%s /usr/bin/fc-cache /%s" % (chrootcmd, fontdir))

    encodingdir = '/usr/X11R6/lib/X11/fonts/encodings'
    mi_core.system("%s /usr/X11R6/bin/mkfontscale /%s" % (chrootcmd, encodingdir))
    mi_core.system("%s /usr/X11R6/bin/mkfontscale /%s" % (chrootcmd, encodingdir + '/large'))

    #mi_core.select(fromdir, todir,
    #               ['usr/X11R6/lib/X11/fonts/misc/fonts.*'],
    #               [])
    mi_core.system("rm -f %s" % ' '.join(map(lambda f: os.path.join(todir, f),
                                    ['usr/X11R6/bin/mkfontdir',
                                     'usr/X11R6/bin/mkfontscale',
                                     #'usr/X11R6/lib/libXfont.so.*',
                                     'usr/bin/fc-cache'])))

    # The font exists in /usr/X11R6/lib/X11/fonts/* do not need fonts.cache-1.
    # If any /usr/share/fonts/* is included, fc-cache can be run to generate
    # fonts.cache-1 to speed up the rendering of the fonts. Note that
    # /etc/fonts/* have to be copied into todir.
