#!/usr/bin/python

### Global information ###

# distname is used to specify the name of the installed distribution.
#
#distname='AutoDistribution'

# distver is used to specify the version of the installed distribution.
#
#distver='0.0'

# distkernelver is used to specify the kernel version which used by the
# installed distribution.
#
#distkernelver='2.4.22-1'

# pkgtype is used to specify the package management scheme used by the
# installed distribution. Now only 'rpm' is supported.
#
#pkgtype='rpm'

# pkgdirs is used to specify the directories which contain the packages
# which should be installed by MagicInstaller as a part of the installed
# distribution. Multiple directories can be separated by ':'. This value
# can be overrided through the command line argument of scons.
#
#pkgdirs='spec/packages'

# langset is used to specify the language set supported in installation
# progress. It is a 'colon' separated string.
#
langset='zh_CN:en'


### Information provided for MagicBooter ###

# welcome message is used to show in the first message box for magicbooter
# which should be provided in English only. Note that this string will be
# placed into m4 command and put into C string, so be carefully about '\n'.
#
# welcome="Welcome to the Auto Distribution provided by MagicInstaller."

# kmods_arrange is map which key is the boot/driver floppy disk name and
# the value is the modules which should be placed in. The item with 'boot'
# key specify the modules which should be distributed with boot floppy disk.
# In the module list, module name can be used directly, directory is also
# permitted. And item prefixed with '@' will be added forcely, otherwise
# the modules which are not exists in pcitable will be omitted.
#
# kmods_arrange = {
#   "boot" : [ '@ext3.o', '@jfs.o', '@ntfs.o', '@reiserfs.o', '@vfat.o' ],
#   "scsi" : [ '@xfs.o', '@sd_mod.o', '@kernel/drivers/md', 'kernel/drivers/scsi' ],
#   "net" : ['@xfs.o', '@kernel/drivers/md', 'kernel/drivers/net' ]
# }
#
# if mikernelver in mi_config.py is 2.6
# kmods_arrange = {
#   "boot" : [ '@jfs.ko' ],
#   "scsi" : [ '@xfs.ko', '@kernel/drivers/scsi' ],
#   "net" : ['@xfs.ko', '@kernel/drivers/net' ]
# }


### Information about package arrangement ###

# volume_limit_list is used to divide the packages into several media.
# Because one CDROM can't store any data more than 650MB, and the current
# distribution always exceed this limitation, so there should be a way to
# arrange the packages into more then one CDROMs. volume_limit_list list
# the volume limitation for each media in bytes.
#
#volume_limit_list = [620*1024*1024, 640*1024*1024, 640*1024*1024]

# placement_list is used to list the package that must be put in which media.
# For example:
#   [['mktemp-1.5-18.i386.rpm'], ['bash-2.05b-20.i386.rpm'], []]
#   which means 'mktemp' must be put into the first media, 'bash' must be put
#   into the first media or second media. and so on.
#
#placement_list = [[]]

# toplevel_groups is used to create groups for the user convenience.
# toplevel_groups is a map. The key is the map name, the value is the map
# package list. This script will resolve the dependency automatically and
# put it into the output result.
# Note that the key 'lock' has different meaning, the packages in 'lock'
# group will be installed forcely.
# For example:
# { 'lock':  ['bash-2.05b-20.i386.rpm'],
#   'gnome': ['gnome-desktop-2.2.0.1-4.i386.rpm',
#             'gnome-applets-2.2.0-8.i386.rpm',
#             ...]}
#
#toplevel_groups = {}

# add_deps is used to add the lost dependencies.
# add_deps is a map which key is the package and the value is the list of
#   the packages that the package depends.
# For example:
#  { 'libacl1-2.2.4-1.i386.rpm' : ['libattr1-2.2.0-1.i386.rpm'] }
#
#add_deps = {}

# remove_deps is used to resolve the loop dependencies.
# remove_deps is a map which key is the package and the value is the list of
#   the packages that the package shouldn't remove depends.
# For example:
#  { 'pam-0.75-49.i386.rpm' : ['initscripts-7.14-9.i386.rpm'] }
#
#remove_deps = {}

# For the detail to deal with loop dependencies between packages, refer to
# the comments and code in scripts/PkgArrange.py.
